%define sgedir /sge

Summary: The Grid Engine for Warewulf
Name: gridengine
Version: 5.3p6
Release: 8.caos
Group: Applications/System
Copyright: SISSL
URL: http://gridengine.sunsource.net/
Source0: sge-V53p6_TAG-src.tar.gz
Source1: configuration
Source2: settings.csh
Source3: settings.sh
Source4: rcsge
Source5: complexes.host
Source6: complexes.queue
Source7: sge-lam.tar.gz
#Patch0: aimk.site.dif
#Patch1: distinst.site.dif
#Patch2: aimk.dif
#Patch3: warnings.dif
Patch0: qtcsh.diff
Requires: pdksh, ncurses, openmotif, warewulf
BuildRequires: openmotif-devel
BuildRequires: XFree86-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Vendor: Sunsoft/Warewulf
Packager: Warewulf -- Greg Kurtzer <greg@runlevelzero.net>

%package node
Summary: Files and configuration for the client nodes runing SGE.
Group: Applications/System

%description
Sun[tm] Grid Engine finds a pool of idle resources and harnesses it
productively, so an organization gets as much as five to ten times the
usable power out of systems on the network. That can increase utilization
to as much as 98%.

Sun Grid Engine software aggregates available compute resources and
delivers compute power as a network service.

This is the Warewulf implementation of the SGE. It consists of two
subpackages; The master RPM, and the client node RPM. This package is 
designed and configured to be used with the Warewulf cluster system.

%description node
Sun[tm] Grid Engine finds a pool of idle resources and harnesses it
productively, so an organization gets as much as five to ten times the
usable power out of systems on the network. That can increase utilization
to as much as 98%.

Sun Grid Engine software aggregates available compute resources and
delivers compute power as a network service.

This is the Warewulf implementation of the SGE. It consists of two
subpackages; The master RPM, and the client node RPM. This package is 
designed and configured to be used with the Warewulf cluster system.


%prep
# create a top level directory
%setup -q -n gridengine
%patch -p0
#fix the complex conflict in man5 
mv doc/man/man5/complex.5 doc/man/man8/complex.8

exit

# set up the target installation directory
mkdir -p $RPM_BUILD_ROOT%{sgedir}

# need to turn off the execution bit in order to avoid wrong dependencies
chmod a-x source/dist/util/update_commands/accounting.awk


%build
cd source
find -name "CVS" | xargs rm -rf
# creates the sge-depend tool
./aimk -only-depend
scripts/zerodepend
# creates the dependencies
./aimk depend
# creates the core programs, qmon, qmake and qrsh/qtcsh
./aimk 
# somehow the processing of the man files needs the CVSROOT to be set
export CVSROOT=":pserver:anoncvs@cvs.sunsource.net:/cvs"
./aimk -man

%install 
cd source
ln -s scripts/distinst myinst
export SGE_ROOT=$RPM_BUILD_ROOT%{sgedir}
mkdir -p $SGE_ROOT
# creates the linux distribution of gridengine
echo "Y" | ./myinst -allall glinux
install -d $SGE_ROOT/default
install -d $SGE_ROOT/default/common
install -d $SGE_ROOT/default/common/history
install -d $SGE_ROOT/default/common/local_conf
install -d $RPM_BUILD_ROOT/etc/profile.d
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 %{SOURCE2} $SGE_ROOT/default/common/
install -m 755 %{SOURCE3} $SGE_ROOT/default/common/
install -m 755 %{SOURCE4} $SGE_ROOT/default/common/
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/profile.d/gridengine.csh
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT/etc/profile.d/gridengine.sh
install -m 644 %{SOURCE1} $SGE_ROOT/default/common/
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/admin_hosts
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/ckpt
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/complexes
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/exec_hosts
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/job_scripts
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/jobs
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/pe
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/queues
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/submit_hosts
install -d $RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster/usersets
tar xvzf %SOURCE7 -C $SGE_ROOT

# Add default complexes
cd $SGE_ROOT
QMASTERDIR=$RPM_BUILD_ROOT/var/spool/gridengine/default/qmaster
install -d $QMASTERDIR/complexes
install -m 644 %{SOURCE5} $QMASTERDIR/complexes/host
install -m 644 %{SOURCE6} $QMASTERDIR/complexes/queue

install -m 644 util/sge_aliases  $SGE_ROOT/default/common
install -m 644 util/qtask   $SGE_ROOT/default/common
install -m 644 util/sge_request   $SGE_ROOT/default/common
echo "sge" >   $SGE_ROOT/default/common/product_mode

# rc.d startup/shutdown scripts
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 0755 %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d


# create the man and documentation directories
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man{1,3,5,8}
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# moving the man files into the correct man dirs
install -m 644 $RPM_BUILD_ROOT%{sgedir}/man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 $RPM_BUILD_ROOT%{sgedir}/man/man5/* $RPM_BUILD_ROOT%{_mandir}/man5
install -m 644 $RPM_BUILD_ROOT%{sgedir}/man/man8/* $RPM_BUILD_ROOT%{_mandir}/man8
rm -rf $RPM_BUILD_ROOT%{sgedir}/man

# moving the documentation into the correct dir
install -m 644 $RPM_BUILD_ROOT%{sgedir}/doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf $RPM_BUILD_ROOT%{sgedir}/doc/

%clean
rm -rf $RPM_BUILD_ROOT


%post
HOSTNAME=`/bin/hostname 2>/dev/null`
if [ -z "$HOSTNAME" ]; then
   HOSTNAME="localhost"
fi
touch %{sgedir}/default/common/act_qmaster
touch %{sgedir}/default/common/local_conf/$HOSTNAME
echo $HOSTNAME > %{sgedir}/default/common/act_qmaster
echo "conf_version           2" > %{sgedir}/default/common/local_conf/$HOSTNAME
echo "mailer                 /bin/mail" >> %{sgedir}/default/common/local_conf/$HOSTNAME
echo "xterm                  /usr/bin/X11/xterm" >> %{sgedir}/default/common/local_conf/$HOSTNAME
echo "qlogin_command         rsh" >> %{sgedir}/default/common/local_conf/$HOSTNAME
echo "qlogin_daemon          /usr/sbin/in.rlogind" >> %{sgedir}/default/common/local_conf/$HOSTNAME
echo "rlogin_daemon          /usr/sbin/in.rlogind" >> %{sgedir}/default/common/local_conf/$HOSTNAME

echo $HOSTNAME > %{sgedir}/default/common/primary_qmaster

if grep "^sge_commd" /etc/services >/dev/null
then
	true
else
	echo "sge_commd          535/tcp     # communication port for Grid Engine" >>/etc/services
	echo "sge_commd          535/udp     # communication port for Grid Engine" >>/etc/services
fi


# Create the missing symlinks
cd %{sgedir}/bin/glinux
ln -sf qstat qselect
ln -sf qalter qresub
ln -sf qsh qlogin
ln -sf qsh qrsh
ln -sf ../../util/qhold.sh qhold
ln -sf ../../util/qhold.sh qrls
cd %{sgedir}/qmon/PIXMAPS
ln -sf intro-sge.xpm intro.xpm
ln -sf logo-sge.xpm logo.xpm

# symlink the missing man files to the correct ones
cd $RPM_BUILD_ROOT%{_mandir}/man1
rm -f qsub.1.gz qsh.1.gz qlogin.1.gz qrsh.1.gz qalter.1.gz qresub.1.gz
ln -s submit.1.gz qsub.1.gz
ln -s submit.1.gz qsh.1.gz
ln -s submit.1.gz qlogin.1.gz
ln -s submit.1.gz qrsh.1.gz
ln -s submit.1.gz qalter.1.gz
ln -s submit.1.gz qresub.1.gz
cd $CWD

# add the complexes for host and queue
source /etc/profile.d/gridengine.sh

# sets the gridengine script to start execd on boot
sed -e 's,^execd=true,execd=false,' $SGE_ROOT/default/common/rcsge > /etc/rc.d/init.d/rcsge
chmod 755 /etc/rc.d/init.d/rcsge

# start the gridengine script
echo
echo "Starting the SGE processes"
/etc/rc.d/init.d/rcsge start
/sbin/chkconfig rcsge on

# adds this node as a submit host
qconf -Ac host /var/spool/gridengine/default/qmaster/complexes/host
qconf -Ac queue /var/spool/gridengine/default/qmaster/complexes/queue
qconf -as $HOSTNAME

if [ -f "/usr/sbin/wwmaster.info" ]; then
   if ! grep "^%{sgedir}" /etc/exports >/dev/null 2>&1; then
      echo "Adding the %{sgedir} export to /etc/exports and restarting NFS"
      echo "%{sgedir}   `/usr/sbin/wwmaster.info --sharedfs_net`/`/usr/sbin/wwmaster.info --sharedfs_msk`(rw,no_root_squash)" >> /etc/exports
      service nfs restart
   fi
else
   echo "Don't forget to add %{sgedir} to the /etc/exports for your sharedfs network"
fi

%post node
mkdir %{sgedir}

if grep "^sge_commd" /etc/services >/dev/null
then
	true
else
	echo "sge_commd          535/tcp     # communication port for Grid Engine" >> /etc/services
	echo "sge_commd          535/udp     # communication port for Grid Engine" >> /etc/services
fi

if ! grep "rcsge -execd" /etc/rc.local >/dev/null 2>&1; then
   echo "/etc/rc.d/init.d/rcsge -execd" >> /etc/rc.local
fi

%preun
# stop the gridengine script
if [ -f /etc/rc.d/init.d/rcsge ];
then
   /etc/rc.d/init.d/rcsge stop >& /dev/null 
   # kill errant sge processes
   ps ax | grep sge_ | grep -v "grep sge_" | for i in `awk '{print $1}'`; do kill -9 $i >& /dev/null; done
fi

%postun
grep -v "^sge_commd" /etc/services >/tmp/services
cat /tmp/services > /etc/services
rm -f /tmp/services

grep -v "^%{sgedir}" /etc/exports > /tmp/exports
cat /tmp/exports > /etc/exports
rm -f /tmp/exports

/etc/rc.d/init.d/nfs restart >& /dev/null

# remove the sge directories
rm -rf %{sgedir}
rm -rf /var/spool/gridengine

%postun node
grep -v '^sge_commd' /etc/services > /tmp/services
cat /tmp/services > /etc/services
rm -f /tmp/services

grep -v "rcsge -execd" /etc/rc.local > /tmp/rc.local
cat /tmp/rc.local > /etc/rc.local
rm -f /tmp/rc.local

%files
%defattr(-, root, root)
%{sgedir}
/var/spool/gridengine
/etc/rc.d/init.d/rcsge
/etc/profile.d/gridengine.csh
/etc/profile.d/gridengine.sh
%{_mandir}/*/*
%{_docdir}/%{name}-%{version}/*

%files node
/etc/rc.d/init.d/rcsge

%changelog
* Mon Apr 11 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Updated the source tree to 5.3p6
- Misc various smaller fixes to the SPEC
- removed /etc/warewulf/enviornment pre-requirement for temporary build

* Sat Oct 12 2002 Greg Kurtzer <GMKurtzer@lbl.gov> 5.3-ww1
- Modified spec so it autoconfigures itself for a Warewulf cluster
- Based Warewulf's SGE spec from Najib's SRPM for NPACI ROCKS

* Wed Jun 26 2002 Najib Ninaba <najib@remorseful.org> 5.3-6
- Added default complexes for host and queue

* Mon Jun 10 2002 Najib Ninaba <najib@remorseful.org> 5.3-5
- renamed to gridengine
- Fixed some SuSE centric paths to NPACI ROCKS centric paths 

* Tue Jun 04 2002 Najib Ninaba <najib@remorseful.org> 5.3-4
- Incorporated some stuff from SuSE. Permission given by Anas Nashif

* Wed May 29 2002 Najib Ninaba <najib@remorseful.org> 5.3-3
- Redoing the NPACI Rocks integration

* Fri May 03 2002 Najib Ninaba <najib@remorseful.org> 5.3-2
- Fixed the misplaced manfiles from section 3 

* Sun Apr 28 2002 Najib Ninaba <najib@remorseful.org> 5.3-1
- Changed to /opt/sge to be more LSB compliant
- Updated to SGE version 5.3

* Wed Mar 20 2002 Najib Ninaba <najib_ninaba@yahoo.com> 5.2.3-4
- Fixed the missing symlinks

* Wed Jan 31 2002 Najib Ninaba <najib_ninaba@yahoo.com> 5.2.3-3
- Fixed the missing symlinks

* Tue Jan 29 2002 Najib Ninaba <najib_ninaba@yahoo.com> 5.2.3-2
- Now packaging sge into Rocks cluster distro
- Followed the pbs directory layout in Rocks under /usr/apps
- Also moved the man files to the proper directories

* Wed Jan 23 2002 Najib Ninaba <najib_ninaba@yahoo.com> 5.2.3-1
- My first attempt
